#include <Wire.h>  // binde Bibliothek Wire fuer I2C ein (LiquidCrystal_I2C braucht diese Bibliothek)
#include <LiquidCrystal_I2C.h> //LCD Bibliothek
#include <Servo.h>
#include <millisDelay.h>
#define LCD_ROWS  2
#define LCD_COLS  16
#define BUTTON_PIN  6
millisDelay VentilDelay1;//Timer für die einzelnen Ventile
millisDelay VentilDelay2;
millisDelay VentilDelay3;
millisDelay VentilDelay4;
millisDelay VentilDelay5;
millisDelay VentilDelay6; 
millisDelay MixenDelay; //Timer für den Mixer-Motor
millisDelay ShaServDelay; //Timer für den Servo, welcher den Shaker ausgießt
millisDelay ZuckerDelay; //Timer für den Zuckerspender
Servo ShakerServo; //Erstellt für das Programm ein Servo mit dem Namen „ShakerServo“
Servo EisServo; //Erstellt für den Eisspender ein Servo mit dem Namen „EisServo“
LiquidCrystal_I2C lcd(0x27, LCD_COLS, LCD_ROWS);

//Unsere Variablen ----------------------------------------------------------------------------------------------------------

int Shakerpos = ShakerServo.read();
int ausgiessen = 0;
bool Shakerleer = false;
bool geleert = false;
bool offenes_Ventil[7];
//VentDel ist ein Pointer Array, damit alle sechs Ventile gleichzeitig und mit einer Funktion angesteuert werden können.
millisDelay (*VentDel[7]) = {NULL, &VentilDelay1, &VentilDelay2, &VentilDelay3, &VentilDelay4, &VentilDelay5, &VentilDelay6};
bool Ventiloffen[7] = {false};
bool mixt = false;
bool gemixt = false;
bool (*pRezept[4]) () = {&Rezept1, &Rezept2, &Rezept3, &Rezept4};
bool Rezeptlauft[4] = {false};
int btn = 0;

void setup() {
  Serial.begin(9600);

  //Ventile -------------
  pinMode(2, OUTPUT);
  pinMode(3, OUTPUT);
  pinMode(4, OUTPUT);
  pinMode(5, OUTPUT);
  pinMode(7, OUTPUT);
  pinMode(8, OUTPUT);

  // Motoren ------------
  pinMode(6, OUTPUT);
  pinMode(11, OUTPUT);

  // Servos -------------
  ShakerServo.attach(9);
  EisServo.attach(10);

  // LCD ----------------
  lcd.begin();
  lcd.backlight();
}

void loop() {
  btn = getButton();
  if (btn == 0) {
    if (Rezeptlauft[0] == false) {
      Rezept1();
      lcd.clear();
      lcd.print("Mixe Rezept1");
      Serial.println(Rezeptlauft[0]);
    }
  }
  if (btn == 1) {
    if (mixt == false) {
      Mixen(2500);
      lcd.clear();
      lcd.print("Mixe");
      Serial.print("mixt: ");Serial.println(mixt);
    }
  }
  //Serial.print("btn: "); Serial.println(btn);
  if (ShaServDelay.justFinished()) {
    ShaServDelay.repeat();
    Shakerpos = ShakerServo.read();
    //ShakerServo.write(Shakerpos);
    //Serial.print("Shakerpos: ");
    //Serial.println(Shakerpos);

    if (Shakerpos <= 175 && ausgiessen == 0) {
      //Serial.println("Shakerleer: ");
      //Serial.println(Shakerleer);
      if (Shakerleer == false) {
        Shakerpos = 1 + Shakerpos;
        ShakerServo.write(Shakerpos);
        //Serial.print("rechnen1: ");
        //Serial.println(Shakerpos);

      } else if (Shakerleer == true) {
        Shakerpos = Shakerpos - 1;
        ShakerServo.write(Shakerpos);
        //Serial.println("rechnen2: ");
        //Serial.println(Shakerpos);
      }
    }
    if (Shakerpos > 175 && ausgiessen == 0) {
      //Serial.println("rückweg");
      Shakerleer = true;
      Shakerpos = 169;
      ShakerServo.write(Shakerpos);
      ausgiessen = 5;
    }
    if (ausgiessen > 0) {
      ausgiessen = ausgiessen - 1;
    }
    if (Shakerpos < 75 && Shakerleer == true) {
      Serial.println("fertig geshaked");
      Shakerpos = 0;
      ShakerServo.write(Shakerpos);
      Shakerleer = false;
      Shakerpos = ShakerServo.read();
      ShaServDelay.stop();
      geleert = true;
    }
  }
  for (int i; VentDel[i]->justFinished(); i++) {
    Serial.println("Timer Abgelaufen");
    Ventil(i, 0, true);
    //Ventiloffen[i] = false;
    Serial.print("i: "); Serial.println(i);
  }
  if (MixenDelay.justFinished()) {
    digitalWrite(11, LOW);
    gemixt = true;
    mixt = false;
    Serial.println("gemixt");
  }
  if (ZuckerDelay.justFinished()) {
    digitalWrite(6, LOW);
    Serial.println("gezuckert");
  }
  for (int i; Rezeptlauft[i] == true; i++) {
    pRezept[i];
  }
}
