#include <Wire.h>  // binde Bibliothek Wire fuer I2C ein (LiquidCrystal_I2C braucht diese Bibliothek)
#include <LiquidCrystal_I2C.h> //LCD Bibliothek
#include <Servo.h>
#include <millisDelay.h>
#define LCD_ROWS  2
#define LCD_COLS  16
#define BUTTON_PIN  6
#define leer_stop 175
#define leer_start 75
#define mix_PWM 45    //senkt die Ausgangsspannung auf 3V
#define zucker_PWM 70 //senkt die Ausgangsspannung auf 8,2V (Motorspannung 9V)
#define eisOffen 175
#define eisZu 75
#define eisZeit 500
millisDelay VentilDelay1;//Timer für die einzelnen Ventile
millisDelay VentilDelay2;
millisDelay VentilDelay3;
millisDelay VentilDelay4;
millisDelay VentilDelay5;
millisDelay VentilDelay6; 
millisDelay MixenDelay; //Timer für den Mixer-Motor
millisDelay ShaServDelay; //Timer für den Servo, welcher den Shaker ausgießt
millisDelay ZuckerDelay; //Timer für den Zuckerspender
millisDelay EisDelay; //Timer für den Eisspender
Servo ShakerServo; //Erstellt für das Programm ein Servo mit dem Namen „ShakerServo“
Servo EisServo; //Erstellt für den Eisspender ein Servo mit dem Namen „EisServo“
LiquidCrystal_I2C lcd(0x27, LCD_COLS, LCD_ROWS);

//Unsere Variablen ----------------------------------------------------------------------------------------------------------
      //leeren
int Shakerpos = ShakerServo.read();
int ausgiessen = 0;
bool Shakerleer = false;
bool geleert = false;
bool leeren = false;
      //Ventile
//VentDel ist ein Pointer Array, damit alle sechs Ventile gleichzeitig und mit einer Funktion angesteuert werden können.
//millisDelay (*VentDel[7]) = {NULL, &VentilDelay1, &VentilDelay2, &VentilDelay3, &VentilDelay4, &VentilDelay5, &VentilDelay6};
bool Ventiloffen[7] = {false};
      //Mixen
bool mixt = false;
bool gemixt = false;
      //Zucker
bool zuckert = false;
      //Eis
int eisZiel = 0;
int eisZahler = 0;
bool eisFertig = false;
      //Rezepte
bool (*pRezept[4]) () = {&Rezept1, &Rezept2, &Rezept3, &Rezept4};
bool Rezeptlauft[4] = {false};
bool amMischen = false;
int btn = 0;
bool lcd_refresh = false;

void setup() {
  Serial.begin(9600);

  //Ventile -------------
  pinMode(2, OUTPUT);
  pinMode(3, OUTPUT);
  pinMode(4, OUTPUT);
  pinMode(5, OUTPUT);
  pinMode(7, OUTPUT);
  pinMode(8, OUTPUT);

  // Motoren ------------
  pinMode(6, OUTPUT);  //Zucker
  pinMode(11, OUTPUT); //mixer

  // Servos -------------
  ShakerServo.attach(9);
  EisServo.attach(10);

  // LCD ----------------
  lcd.begin();
  lcd.backlight();
  lcd.print("Cocktail'o'mat");
  delay(500);
}

void loop() {
  //------------------------| Serielle Kontrolle |-----------------------------------------------------------------------------------------------------
  char c = 0;
  if (Serial.available()) {
    c = Serial.read();
    while (Serial.available()) {
      Serial.read(); // clear rest on input
    }
  }
  if (c == '1') {  // Kontrolle der einzelnen Funktionen über die Tastatur
        if (VentilDelay1.isRunning()) {
      Serial.println("Ventil1 blockiert");
    } else {
      Ventil1(3000, false);
    }
  } else if (c == '2') {
        if (VentilDelay2.isRunning()) {
      Serial.println("Ventil2 blockiert");
    } else {
      Ventil2(3000, false);
    }
  } else if (c == '3') {
        if (VentilDelay3.isRunning()) {
      Serial.println("Ventil3 blockiert");
    } else {
      Ventil3(3000, false);
    }
  } else if (c == '4') {
        if (VentilDelay4.isRunning()) {
      Serial.println("Ventil4 blockiert");
    } else {
      Ventil4(3000, false);
    }
  } else if (c == '5') {
        if (VentilDelay5.isRunning()) {
      Serial.println("Ventil5 blockiert");
    } else {
      Ventil5(3000, false);
    }
  } else if (c == '6') {
        if (VentilDelay6.isRunning()) {
      Serial.println("Ventil6 blockiert");
    } else {
      Ventil6(3000, false);
    }
  } else if ((c == 'Q') || (c == 'q')) {
    Shakerleeren(30);
    Serial.println("Shakerleeren 30ms/step");
  } else if ((c == 'W') || (c == 'w')) {
    Mixen(3000);
    Serial.println("3sec Mixen");
  } else if ((c == 'E') || (c == 'e')) {
    Eis(1);
    Serial.println("1mal Eiswürfel");
  } else if ((c == 'R') || (c == 'r')) {
    Zucker(5000);
    Serial.println("2sec Zucker");
  } else if ((c == '\n') || (c == '\r')) {
    // skip end of line chars
  } else if (c != 0) {
    Serial.print("Invalid cmd:"); Serial.println(c);
  }
  //------------------------| Bedienung |--------------------------------------------------------------------------------------------------------------
  btn = getButton();
  if (btn == 3) {         //Diese if.funktionen starten die Rezept funktion nachdem die dazugehörige Taste gedrückt wurde.
    if (Rezeptlauft[0] == false && !amMischen) {
      Rezept1();
      lcd.clear();
      lcd.print("Mixe Rezept1");
      //Serial.println(Rezeptlauft[0]);
    }
  }
  if (btn == 2) {
    if (Rezeptlauft[1] == false && !amMischen) {
      Rezept2();
      lcd.clear();
      lcd.print("Mixe Rezept2");
      //Serial.println(Rezeptlauft[1]);
    }
  }
  if (btn == 1) {
    if (Rezeptlauft[2] == false && !amMischen) {
      Rezept3();
      lcd.clear();
      lcd.print("Mixe Rezept3");
      //Serial.println(Rezeptlauft[2]);
    }
  }
  if (btn == 0) {
    if (Rezeptlauft[3] == false && !amMischen) {
      Rezept4();
      lcd.clear();
      lcd.print("Mixe Rezept4");
      //Serial.println(Rezeptlauft[3]);
    }
  }
  if (!Rezeptlauft[0] && !Rezeptlauft[1] && !Rezeptlauft[2] && !Rezeptlauft[3]) {  //schreibt welsches Rezept auf welchen Knopf ist auf den LCD
    if (!lcd_refresh) {
      lcd_refresh = true;
      lcd.clear();
      lcd.print("Rezept1 Rezept3");
      lcd.setCursor(1,1);
      lcd.print("Rezept2 Rezept4");
    }
  }
  //Serial.print("btn: "); Serial.println(btn);
  //-------------------------| Funktionen |-------------------------------------------------------------------------------------------------------------
  if (ShaServDelay.justFinished()) {
    Shakerleeren(20);     // die 20 ist nur ein Platzhalter und wird in der Funktion zu diesem Zeitpunkt nicht mehr benutzt
    /*ShaServDelay.repeat();
    Shakerpos = ShakerServo.read();
    //ShakerServo.write(Shakerpos);
    //Serial.print("Shakerpos: ");
    //Serial.println(Shakerpos);

    if (Shakerpos <= 175 && ausgiessen == 0) {
      //Serial.println("Shakerleer: ");
      //Serial.println(Shakerleer);
      if (Shakerleer == false) {
        Shakerpos = 1 + Shakerpos;
        ShakerServo.write(Shakerpos);
        //Serial.print("rechnen1: ");
        //Serial.println(Shakerpos);

      } else if (Shakerleer == true) {
        Shakerpos = Shakerpos - 1;
        ShakerServo.write(Shakerpos);
        //Serial.println("rechnen2: ");
        //Serial.println(Shakerpos);
      }
    }
    if (Shakerpos > 175 && ausgiessen == 0) {
      //Serial.println("rückweg");
      Shakerleer = true;
      Shakerpos = 169;
      ShakerServo.write(Shakerpos);
      ausgiessen = 5;
    }
    if (ausgiessen > 0) {
      ausgiessen = ausgiessen - 1;
    }
    if (Shakerpos < 75 && Shakerleer == true) {
      Serial.println("fertig geshaked");
      Shakerpos = 0;
      ShakerServo.write(Shakerpos);
      Shakerleer = false;
      Shakerpos = ShakerServo.read();
      ShaServDelay.stop();
      geleert = true;
    }*/
  }
  /*for (int i; VentDel[i]->justFinished(); i++) {        // Das ist der Code um die Ventil-funktion mit Pointern funktionieren zu lassen.
    Serial.println("Timer Abgelaufen");
    Ventil(i, 0, true);
    //Ventiloffen[i] = false;
    Serial.print("i: "); Serial.println(i);
  }*/
  if (VentilDelay1.justFinished()) {                    // Da die Pointer nicht funktioniert haben haben wir für jedes Ventil eine eigene if-funktion bei ablauf des Timers benutzt.
    Serial.println("Timer1 Abgelaufen");
    Ventil1(0, true); // Der zweite parameter sorgt dafür das das Ventil wieder geschlossen wird.
    //Ventiloffen[i] = false;
    //Serial.print("i: "); Serial.println(i);
  }
  if (VentilDelay2.justFinished()) {
    Serial.println("Timer2 Abgelaufen");
    Ventil2(0, true);
    //Ventiloffen[i] = false;
    //Serial.print("i: "); Serial.println(i);
  }
  if (VentilDelay3.justFinished()) {
    Serial.println("Timer3 Abgelaufen");
    Ventil3(0, true);
    //Ventiloffen[i] = false;
    //Serial.print("i: "); Serial.println(i);
  }
  if (VentilDelay4.justFinished()) {
    Serial.println("Timer4 Abgelaufen");
    Ventil4(0, true);
    //Ventiloffen[i] = false;
    //Serial.print("i: "); Serial.println(i);
  }
  if (VentilDelay5.justFinished()) {
    Serial.println("Timer5 Abgelaufen");
    Ventil5(0, true);
    //Ventiloffen[i] = false;
    //Serial.print("i: "); Serial.println(i);
  }
  if (VentilDelay6.justFinished()) {
    Serial.println("Timer6 Abgelaufen");
    Ventil6(0, true);
    //Ventiloffen[i] = false;
    //Serial.print("i: "); Serial.println(i);
  }
  if (MixenDelay.justFinished()) {
    digitalWrite(11, LOW); // Da einfach ein PWM-Signal auf Pin11 ausgegeben wird können wir Pin11 einfach LOW schreiben um die Funktion zu beenden.
    gemixt = true;
    mixt = false;
    Serial.println("gemixt");
  }
  if (ZuckerDelay.justFinished()) {
    digitalWrite(6, LOW);   // Da einfach ein PWM-Signal auf Pin6 ausgegeben wird können wir Pin6 einfach LOW schreiben um die Funktion zu beenden.
    zuckert = false;
    Serial.println("gezuckert");
  }
  if (EisDelay.justFinished()) {
    EisServo.write(75);
    Eis(eisZiel);
  }
  //------------------------| Rezepte |-----------------------------------------------------------------------------------------------------------------
  if (Rezeptlauft[0]) {     // Diese if-funktionen sorgen dafür das die Rezept-funktion die gerade ausgeführt wird wiederholt wird bis sie fertig ist.
    if (Rezept1()) {
      Serial.println("Rezept 1 fertig");
    }
  }
  if (Rezeptlauft[1]) {
    if (Rezept2()) {
      Serial.println("Rezept 2 fertig");
    }
  }
  if (Rezeptlauft[2]) {
    if (Rezept3()) {
      Serial.println("Rezept 3 fertig");
    }
  }
  if (Rezeptlauft[3]) {
    if (Rezept4()) {
      Serial.println("Rezept 4 fertig");
    }
  }
}
